#****************************************************************************
#**
#**  File     :  rampage_weapons.lua
#**  Author(s):  Author(s): Resin_Smoker (Weapon Templates by:Exavier Macbeth)
#**
#**  Summary  :  
#**
#**  Copyright  2007
#****************************************************************************

local WeaponFile = import('/lua/sim/defaultweapons.lua')
local CollisionBeams = import('/lua/defaultcollisionbeams.lua')
local BareBonesWeapon = WeaponFile.BareBonesWeapon
local DefaultProjectileWeapon = WeaponFile.DefaultProjectileWeapon
local DefaultBeamWeapon = WeaponFile.DefaultBeamWeapon
local GinsuCollisionBeam = CollisionBeams.GinsuCollisionBeam
local EffectTemplate = import('/lua/EffectTemplates.lua')

NapalmMissileProjectile = Class(DefaultProjectileWeapon) {
    #FxMuzzleFlash = EffectTemplate.TAAMissileLaunchNoBackSmoke,

    CreateProjectileForWeapon = function(self, bone)
        local projectile = self:CreateProjectile(bone)
        local damageTable = self:GetDamageTable()
        local blueprint = self:GetBlueprint()
        local data = {
            Instigator = self.unit,
            Damage = blueprint.DoTDamage,
            Duration = blueprint.DoTDuration,
            Frequency = blueprint.DoTFrequency,
            Radius = blueprint.DamageRadius,
            Type = 'Normal',
            DamageFriendly = blueprint.DamageFriendly,
        }
        if projectile and not projectile:BeenDestroyed() then
            projectile:PassData(data)
            projectile:PassDamageData(damageTable)
        end
        return projectile
    end,

}

Over_ChargeProjectile = Class(DefaultProjectileWeapon) {}

Rapid_PlasmaProjectile = Class(DefaultProjectileWeapon) {}




