#****************************************************************************
#**  File     :  UAB2204_script.lua
#**
#**  Author(s):  Resin_Smoker & Optimus Prime
#**
#**  Summary  :  Aeon Heavy POP-Up Flak Tower Script
#**
#**  Copyright  13 APRIL 2008
#****************************************************************************

local AStructureUnit = import('/lua/aeonunits.lua').AStructureUnit
local AAATemporalFizzWeapon = import('/lua/aeonweapons.lua').AAATemporalFizzWeapon

UAB2204 = Class(AStructureUnit) {
    Weapons = {
        AAFizz = Class(AAATemporalFizzWeapon) {
            ChargeEffectMuzzles = {'Turret_Right_Muzzle', 'Turret_Left_Muzzle'},
            
            PlayFxRackSalvoChargeSequence = function(self)
                AAATemporalFizzWeapon.PlayFxRackSalvoChargeSequence(self)
                CreateAttachedEmitter( self.unit, 'Turret_Right_Muzzle', self.unit:GetArmy(), '/effects/emitters/temporal_fizz_muzzle_charge_02_emit.bp')
                CreateAttachedEmitter( self.unit, 'Turret_Left_Muzzle', self.unit:GetArmy(), '/effects/emitters/temporal_fizz_muzzle_charge_03_emit.bp')
            end,

            OnGotTarget = function(self)
               if self.unit:IsDead() == false then
                   self.unit.HaveTarget = true
               end
               AAATemporalFizzWeapon.OnGotTarget(self)
            end,

            OnLostTarget = function(self)
               if self.unit:IsDead() == false then
                   self.unit.HaveTarget = false
               end
               AAATemporalFizzWeapon.OnLostTarget(self)
            end,
        },
    },

    OnCreate = function(self,builder,layer)
        AStructureUnit.OnCreate(self,builder,layer)
        if not self:IsDead() then
            self:ForkThread(self.GlobalInitialization)
        end 
    end,

    GlobalInitialization = function(self)
        ### Global Varible setup
        self.HaveTarget = false
    end,

    OnDamage = function(self, instigator, amount, vector, damagetype)
        if self:IsDead() == false and not self:IsUnitState('Attacking') then
            ### 90% reduction while not attacking
            self.DamageReduction = 1.0
        else
            ### 0% reduction while attacking
            self.DamageReduction = 1.0
        end
        amount = math.ceil(amount*self.DamageReduction)
        AStructureUnit.OnDamage(self, instigator, amount, vector, damagetype)
    end,

    OnKilled = function(self, instigator, type, overkillRatio)
        ### Disables weapons
        self:SetWeaponEnabledByLabel('AAFizz', false)

        ### Final command to finish off the drones death event
        AStructureUnit.OnKilled(self, instigator, type, overkillRatio)
    end,

}

TypeClass = UAB2204