#****************************************************************************
#**  File     :  UAB2301_script.lua
#**
#**  Author(s):  Resin_Smoker & Optimus Prime
#**
#**  Summary  :  Aeon Heavy POP-Up Gun Tower Script
#**
#**  Copyright  13 APRIL 2008, 4th Dimension
#****************************************************************************

local AStructureUnit = import('/lua/aeonunits.lua').AStructureUnit

UAB2301 = Class(AStructureUnit) {
   Weapons = {
       MainGun = Class(import('/lua/aeonweapons.lua').ADFCannonOblivionWeapon) {
  FxMuzzleFlash = {
   '/effects/emitters/oblivion_cannon_flash_04_emit.bp',
   '/effects/emitters/oblivion_cannon_flash_05_emit.bp',    
   '/effects/emitters/oblivion_cannon_flash_06_emit.bp',
  },        
       }
   },

   OnDamage = function(self, instigator, amount, vector, damagetype)
       if self:IsDead() == false and not self:IsUnitState('Attacking') then
           ### 90% reduction while not attacking
           self.DamageReduction = 1.0
       else
           ### 0% reduction while attacking
           self.DamageReduction = 1.0
       end
       amount = math.ceil(amount*self.DamageReduction)
       AStructureUnit.OnDamage(self, instigator, amount, vector, damagetype)
   end,

   OnKilled = function(self, instigator, type, overkillRatio)
       ### Disables weapons
       self:SetWeaponEnabledByLabel('MainGun', false)

       ### Final command to finish off the turrets death event
       AStructureUnit.OnKilled(self, instigator, type, overkillRatio)
   end,
}

TypeClass = UAB2301