#****************************************************************************
#**  File     :  UAB2304_script.lua
#**
#**  Author(s):  Resin_Smoker & Optimus Prime
#**
#**  Summary  :  Aeon Heavy POP-Up SAM Tower Script
#**
#**  Copyright  13 APRIL 2008
#****************************************************************************

local AStructureUnit = import('/lua/aeonunits.lua').AStructureUnit
local AAAZealotMissileWeapon = import('/lua/aeonweapons.lua').AAAZealotMissileWeapon

UAB2304 = Class(AStructureUnit) {
    Weapons = {
        AntiAirMissiles = Class(AAAZealotMissileWeapon) {},
            OnGotTarget = function(self)
               if self.unit:IsDead() == false then
                   self.unit.HaveTarget = true
               end
               OblivionWeapon.OnGotTarget(self)
            end,

            OnLostTarget = function(self)
               if self.unit:IsDead() == false then
                   self.unit.HaveTarget = false
               end
               OblivionWeapon.OnLostTarget(self)
            end,
    },
    OnCreate = function(self,builder,layer)
        AStructureUnit.OnCreate(self,builder,layer)
        if not self:IsDead() then
            self:ForkThread(self.GlobalInitialization)
        end 
    end,

    GlobalInitialization = function(self)
        ### Global Varible setup
        self.HaveTarget = false
    end,

    OnDamage = function(self, instigator, amount, vector, damagetype)
        if self:IsDead() == false and not self:IsUnitState('Attacking') then
            ### 90% reduction while not attacking
            self.DamageReduction = 1.0
        else
            ### 0% reduction while attacking
            self.DamageReduction = 1.0
        end
        amount = math.ceil(amount*self.DamageReduction)
        AStructureUnit.OnDamage(self, instigator, amount, vector, damagetype)
    end,

    OnKilled = function(self, instigator, type, overkillRatio)
        ### Disables weapons
        self:SetWeaponEnabledByLabel('AntiAirMissiles', false)

        ### Final command to finish off the drones death event
        AStructureUnit.OnKilled(self, instigator, type, overkillRatio)
    end,
}

TypeClass = UAB2304